# Spojnik.awk (MS-DOS version)
#    usage:  gawk -f spj.awk plik, plik...
# 
# Dodaje nie/lamliwe spacje po sp/ojnikach, przed inicja/lami 
# oraz do niekt/orych skr/ot/ow. Zamienia /laczniki w odpowiednich 
# miejscach na p/o/lpauzy.
#
# Author: TP (5.4.96)
#

BEGIN {
   stdio = "con";
   digit = "[0123456789]"; 
   capletter = "[A-Z]";  # Mazovia format
   lowletter = "[a-z]";  # Mazovia format
   spojnik = "[AIOUWZaiouwz]"; 
   wspace = "[ \\t\\n]+";
   xspace = "[ \\t\\n]*";
   G_ = "(";
   _G = ")";

}

function print_para() {
   len = 0;
   words = split(para, paralist," ");
   for (i=1; i<=words; i++) {
      len += length(paralist[i]);
      ##print len, paralist[i] >> stdio;

      if ( ++len >= 60 ) { printf "%s\n", paralist[i]; len = 0 }
      else { printf "%s ", paralist[i]; }
   }
   if (len) { printf "\n\n"; } else { printf "\n";}
}

function process_para() {
   print "Paragraph: ", length(para), "bytes" >> stdio;

   para = gensub(/[ \t\n]+([AIOUWZaiouwz])[ \t\n]+/, " \\1~", "g", para); 

#   para = gensub(/[~]([AIOUWZaiouwz])[ \t\n]+/, "~\\1~", "g", para);
   gsub(/[ \t\n]+r\./, "~r.",para); # year
   
##   #initials
   para = gensub(G_ capletter _G "\\.[ \t\n]+" G_ capletter lowletter _G,
        "\\1.~\\2","g",para);
   xpara = gensub(G_ capletter _G "\\.[ \t\n]+" G_ capletter "\\.\\~" _G, 
        "\\1.~\\2","g",para);
   
   print para;

   para = xpara;

   #endashes#
   para = gensub(G_ digit _G xspace "-" xspace G_ digit _G, "\\1--\\2", "g", para);

   #now we can convert emdashes#
   gsub(wspace "-" wspace, " -- ", para);

   print_para();
   para = "";
}

{ para = para " " $0; if (match($0,/^[\t ]*$/) ){process_para()} }
END {process_para(); }


